#include <pic.h>

__CONFIG(BORDIS & UNPROTECT &
		MCLRDIS & PWRTEN & WDTDIS & INTIO);

#include "delay.h"

#define	TxData		GPIO5				/* Map TxData to pin */
#define	RxData		GPIO3				/* Map RxData to pin */
#define	TxDataDir	TRISIO5				/* Map TxData to pin */
#define	RxDataDir	TRISIO3				/* Map RxData to pin */

#include "serial.h"


void puts(const char *str)
{
	while(*str)
		putch(*str++);
}

void putdec(unsigned char a)
{
	char znak = '0';
	
	// stovky
	while (a >= 100)
	{
		znak++;
		a -= 100;
	}
	putch( znak );

	// desiatky
	znak = '0';
	while (a >= 10)
	{
		znak++;
		a -= 10;
	}
	putch( znak );

	// jednotky
	
	putch( '0' + a );
}


void main()
{
//	char i; // -128..127
//	unsigned char i; // 0..255
	int i; // -32768..32767
	unsigned char prevod;


	TRISIO2 = 0;

	// nastavenie multiplexora
	CHS1 = 1;
	CHS0 = 1;

	while (1) 
	{
		ADON = 1;
		GODONE = 1;
		while ( GODONE == 1 )
		{
		}

		prevod = ADRESH;

		for (i=0; i<255; i++)
		{
			if ( prevod > i )
				GPIO2 = 1;
			else
				GPIO2 = 0;

			DelayUs(100);
		}
		
		DelayMs(10);
		puts("Hodnota prevodnika : ");
		putdec(prevod);
		puts("  ");
	}
}
