
; HI-TECH Software PICC Assembler header file.
; Definitions based on C header file: pic125xx.h.

; NOTE: PICC assembler option -P is required to preprocess assembler sources. 

; Special Function Register definitions
RTCC		equ	001h
TMR0		equ	001h
PCL		equ	002h
STATUS		equ	003h
FSR		equ	004h
OSCCAL		equ	005h
GPIO		equ	006h
OPTION		equ	000h
TRIS		equ	006h

; Bit variables associates within SFRs
#define GPWUF	STATUS,7
#define PA0	STATUS,5
#define TO	STATUS,4
#define PD	STATUS,3
#define ZERO	STATUS,2
#define DC	STATUS,1
#define CARRY	STATUS,0
#define CAL3	OSCCAL,7
#define CAL2	OSCCAL,6
#define CAL1	OSCCAL,5
#define CAL0	OSCCAL,4
#define CAL5	OSCCAL,7
#define CAL4	OSCCAL,6
#define CAL3	OSCCAL,5
#define CAL2	OSCCAL,4
#define CAL1	OSCCAL,3
#define CAL0	OSCCAL,2
#define CAL6	OSCCAL,7
#define CAL5	OSCCAL,6
#define CAL4	OSCCAL,5
#define CAL3	OSCCAL,4
#define CAL2	OSCCAL,3
#define CAL1	OSCCAL,2
#define CAL0	OSCCAL,1
#define SCL	GPIO,7
#define SDA	GPIO,6
#define GP5	GPIO,5
#define GP4	GPIO,4
#define GP3	GPIO,3
#define GP2	GPIO,2
#define GP1	GPIO,1
#define GP0	GPIO,0
