/* A version of string copy that can copy from any bank to any bank */

#ifdef _PIC16
far char *
strcpy(far char * to, register const char * from)
#else
#if	defined(_PIC14) && (_BANKBITS_==2)
const char *
strcpy(const char *to, const char *from) 
#else
char *
strcpy(char * to, register const char * from)
#endif
#endif
{
#ifdef _PIC16
	register far char *	cp;
#else  
#if	defined(_PIC14) && (_BANKBITS_==2)
	register const char *cp;
#else
	register char *	cp;
#endif
#endif

	cp = to;
#if	defined(_PIC14) && (_BANKBITS_==2)
	if (((unsigned short)cp) >= 0x8100)
			while( *(bank2 char *)cp++ = *from++)
				continue;
	else
			while( *(char *)cp++ = *from++)
				continue;
#else
	while(*cp++ = *from++)
		continue;
#endif
	return to;
}
