;	Long division for PIC 16C5x

#ifdef	_PIC12
	psect	float_text0,class=ENTRY,delta=2,size=512
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text0
#else
	psect	float_text0,class=CODE,delta=2
#endif

	global	aldiv,almod,aldiv_x,doldiv

;	Unsigned division - called with the dividend in btemp+0-btemp+3 and the
;	divisor in btemp+4-btemp+7. The remainder is left in btemp+8

#include	"sfr.h"

aldiv
almod
#ifdef	PIC12
	clrf	fsr_save
#else
	clrf	FSR
#endif
aldiv_x
	SELBANK0
	clrf	flags
	btfss	quot+3,7	;check dividend sign bit
	goto	chkvis
	bcf	STATUS,C
	movlw	0FFh
	addwf	quot
	comf	quot
	btfss	STATUS,C
	addwf	quot+1
	comf	quot+1
	btfss	STATUS,C
	addwf	quot+2
	comf	quot+2
	btfss	STATUS,C
	addwf	quot+3
	comf	quot+3
	bsf	flags,6		;set remainder sign bit
	bsf	flags,7		;set remainder sign bit
chkvis
	movf	visor+3,w	;get divisor
	andlw	80h		;mask out sign bit
	xorwf	flags		;compute quotient sign
	btfss	visor+3,7	;check if negate needed
	goto	doldiv		;nope
	bcf	STATUS,C
	movlw	0FFh
	addwf	visor
	comf	visor
	btfss	STATUS,C
	addwf	visor+1
	comf	visor+1
	btfss	STATUS,C
	addwf	visor+2
	comf	visor+2
	btfss	STATUS,C
	addwf	visor+3
	comf	visor+3
	goto	doldiv		;go do division
	

        psect   temp,global,class=BANK0,space=1,ovrld
quot	ds	4	;quotient
visor	ds	4	;divisor
dend	ds	4	;dividend
        psect   xtemp,ovrld,class=BANK0,space=1
flags	ds	1	;sign bits

#ifdef	_PIC12
	psect	fsr_save,ovrld,class=BANK0,space=1
fsr_save
	ds	1
#endif
	end
