#ifdef	_PIC12
	psect	clrtext,class=ENTRY,delta=2
#else
	psect	clrtext,class=CODE,delta=2
#endif

#include	"sfr.h"

;	Clear the rbss_x psects

	global	clear_ram

;	Called with FSR containing the base address, and
;	W with the last address+1

#ifdef	_PIC16
clear_ram
	clrwdt			;avoid WDT reset in pathological case

	bsf	STATUS,4	;set up auto-increment
	bcf	STATUS,5
	goto	loopent
clrloop
	clrf	INDF,f		;clear memory, auto-increment
loopent
	cpfseq	FSR
	goto	clrloop
	return
#else
	
clrloop
	xorwf	FSR,w		;restore correct value in W
	clrf	INDF		;clear a byte
	incf	FSR,f		;increment pointer
clear_ram
	xorwf	FSR,w
#ifdef	_PIC12
	andlw	1Fh		;Test low bits only
#endif
	btfss	STATUS,2	;test zero
	goto	clrloop

	clrwdt			;avoid WDT reset in pathological case
	retlw	0
#endif	/* _PIC16 */
