#include	<math.h>
#include	<limits.h>
#include	<float.h>

#if	sizeof(double) <= sizeof(long)
#define	_frndint(x)	((double)(long)(x))
#else
extern double	_frndint(double);
#endif


double
floor(double x)
{
	double	i;
	int	expon;

#if	sizeof(double) == sizeof(long) && DBL_MAX_EXP == 128
	expon = ((*(unsigned long *)&x >> (DBL_MANT_DIG-1)) & 255) - 126;
#else
	frexp(x, &expon);
#endif
	if(expon < 0)
		return x < 0.0 ? -1.0 : 0.0;
	if((unsigned)expon > sizeof(double) * CHAR_BIT - 4)
		return x;		/* already an integer */
	i = _frndint(x);
	if(i > x)
		return i - 1.0;
	return i;
}
