;	Copyright (C) 1997 HI-TECH Software 

#include	"double.h"

;	Convert double to long

	global	fltol,flunpack1
	global	l0neg

	FNCALL	fltol,flunpack1
	FNCALL	ftolx,l0neg
	FNCALL	fltol,l0neg

fltol
	clrf	FSR
	call	flunpack1
ftolx				;entry point for unpacked, possibly un-normalized
				;value to be converted
	movlw	1-127		;unbias exponent
	addwf	exp1
	btfsc	exp1,7		;check sign bit
	goto	zerct		;negative - all zeroes
	movlw	-(23+1)		;calculate shift
	addwf	exp1
	btfsc	exp1,7		;check sign bit
	goto	ftol2		;shift has to be right
	movlw	32
	subwf	exp1,w		;check for overflow
	btfsc	STATUS,C
	goto	zerct
ftol3
#ifdef	_PIC16
	movf	exp1,w
	iorlw	0
#else
	movf	exp1		;check for zero
#endif
	btfsc	STATUS,Z
	goto	ftol9		;go do the sign
	decf	exp1
	bcf	STATUS,C
	rlf	mant1+0		;shift up one bit
	rlf	mant1+1
	rlf	mant1+2
	rlf	mant1+3
	goto	ftol3		;loop for more
ftol9
;	btfss	signs,0		;check sign
;	return			;positive!
;	call	l0neg
	btfsc	signs,0		;check sign
	call	l0neg
;	comf	mant1		;negate it - complement and add 1
;	comf	mant1+1
;	comf	mant1+2
;	comf	mant1+3
;	incf	mant1
;	btfsc	STATUS,Z
;	incf	mant1+1
;	btfsc	STATUS,Z
;	incf	mant1+2
;	btfsc	STATUS,Z
;	incf	mant1+3
	return			;all done

;	Here to shift right

ftol2
	bcf	STATUS,C
	rrf	mant1+3		;shift down
	rrf	mant1+2
	rrf	mant1+1
	rrf	mant1+0
	incfsz	exp1
	goto	ftol2
	goto	ftol9
