
;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Multiplication done here


#include	"float.h"

	global	ftmul,ftmul_x
	global	used_btemp9
	global	used_btemp10
	global	used_btemp11

	global	ftunpack1,ftunpack2
	FNCALL	ftmul,ftunpack1
	FNCALL	ftmul,ftunpack2
	FNCALL	ftmul_x,ftunpack1
	FNCALL	ftmul_x,ftunpack2
;
;	Multiply the float in ctemp by the float on the stack and return
;	the result in ctemp

#ifdef	_PIC12
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text4
#endif
ftmul
	clrf	FSR
ftmul_x
	call	ftunpack1
	call	ftunpack2
	clrf	prod
	clrf	prod+1
	clrf	prod+2
	movlw	7		;initialize counter
	movwf	cntr
mup1
	bcf	STATUS,C
	rrf	mant2+1
	rrf	mant2+0
	btfss	STATUS,C	;if bit 0 was set
	goto	nobit
	movf	mant1,w		;add multiplicand to product
	addwf	prod
	movf	mant1+1,w
	btfsc	STATUS,0
	incfsz	mant1+1,w
	addwf	prod+1
	movf	mant1+2,w
	btfsc	STATUS,0
	incfsz	mant1+2,w
	addwf	prod+2
nobit
	bcf	STATUS,C
	rlf	mant1+0		;shift multiplicand up one bit
	rlf	mant1+1
	rlf	mant1+2
	decfsz	cntr		;decrement counter
	goto	mup1		;loop if more

	movlw	9		;re initialize counter
	movwf	cntr
	goto	mup3
mup11
	bcf	STATUS,C
	rrf	prod+2		;shift product down one bit
	rrf	prod+1
	rrf	prod+0
mup3
	bcf	STATUS,C
	rrf	mant2+1		;shift multiplier down one bit+2
	rrf	mant2+0
	btfss	STATUS,C	;was it set
	goto	mup2		;nope, don't add
	movf	mant1,w		;add multiplicand to product
	addwf	prod
	movf	mant1+1,w
	btfsc	STATUS,0
	incfsz	mant1+1,w
	addwf	prod+1
	movf	mant1+2,w
	btfsc	STATUS,0
	incfsz	mant1+2,w
	addwf	prod+2
mup2
	decfsz	cntr		;loop if more
	goto	mup11

	rrf	signs,w		;get sign of RHS in bit 0
	xorwf	signs		;xor with LHS sign
;1:
	movf	prod+0,w		;copy product to mant1
	movwf	mant1+0
	movf	prod+1,w
	movwf	mant1+1
	movf	prod+2,w
	movwf	mant1+2

	movlw	-(127+7)	;get exponent adjustment
	addwf	exp2,w		;add RHS exponent
	addwf	exp1		;add LHS exponent

	goto	ftnorm1		;normalize

        psect   temp,ovrld,class=BANK0,space=1
prod	ds	3
	end
