/*
 * memchr: find a char in a block of memory
 */

#include <string.h>

__CONST void *
memchr(const void *p, int n, size_t v)
{
	register __CONST unsigned char *s = p;

	while (v--)
		if (*s == (unsigned char)n)
			return s;
		else
			++s;
	
	return 0;
}
