#define _USEBANKBITS
#include	"sfr.h"

	global code_ptr
	psect	pstrings,class=CODE,delta=2

#ifdef	_PROGMEM_
psect pstrings
global uses_packed_strings
uses_packed_strings

	CLRBANK0
	rrf	code_ptr+1,w		; divide by 2 to get word address
	andlw	01Fh			; remove top 2 bits
	SEL_PMREGS
	movwf	PMADRH
	SELBANK0
	rrf	code_ptr,w
	SEL_PMREGS
	movwf	PMADR
	SEL_PMCON
#ifdef _TEST_CHIP_
	db	0x20
#else
#ifdef _NEEDS_INTS_OFF_
	INTS_OFF
#else
	bsf	PMCON,7			; read a word of program memory
#endif
	bsf	PMCON,0
	nop
	nop
#ifdef _NEEDS_INTS_OFF_
	INTS_ON
#endif
#endif
	SEL_PMREGS
	movf	PMDATA,w
	CLRBANK0			; select bank 0, clear carry
	btfsc	code_ptr,0		; was the address odd or even?
	goto retchar			; return value in DATA register
	SEL_PMREGS			
	; bcf	STATUS,0		; carry should already be clear
	btfsc	PMDATA,7
	bsf	STATUS,0
	rlf	PMDATH,w		; shift up and OR in top bit of data register
	CLRBANK0
retchar
	andlw	07fh
	return				; return char in W

	psect	code_ptr,global,class=BANK0,space=1,ovrld
	ds	2
#endif
end
