;	Word multiplication for PIC 16C5x

#ifdef	_PIC12
	psect	text,class=ENTRY,delta=2
#else
	psect	text,class=CODE,delta=2
#endif

	global	awmul,lwmul

;	The main multiply thingo. Called with one operand in btemp and the
;	other in btemp+2. It really doesn't matter which one is where.
;	The multiplier is copied to plier, and the product built up in
;	prod where it belongs

#include	"sfr.h"

lwmul
awmul
	SELTEMP
#if	defined(_PIC16) && !defined(_17C42)
	movf	plier,w		;get the multiplier low byte
	mulwf	btemp		;multiply by low byte
	movpf	PRODL,prod
	movpf	PRODH,prod+1
	movf	plier,w		;get the multiplier low byte
	mulwf	btemp+1		;multiply by high byte
	movf	PRODL,w
	addwf	prod+1		;add to result hi byte
	movf	plier+1,w	;get the multiplier high byte
	mulwf	btemp		;multiply by low byte
	movf	PRODL,w
	addwf	prod+1		;add to result hi byte
	return			;done already!

#else
	clrf	prod		;initialize product
	clrf	prod+1
loop
	bcf	STATUS,C	;clear carry again
	rrf	plier+1		;shift multiplier down
	rrf	plier
	btfss	STATUS,C		;skip if multiplier lsb not set
	goto	lop1
	movf	btemp,w		;add multiplicand to product
	addwf	prod
	movf	btemp+1,w
	btfsc	STATUS,C
	incf	btemp+1,w
	addwf	prod+1
lop1
	bcf	STATUS,C	;clear carry
	rlf	btemp		;shift multiplicand up
	rlf	btemp+1
	movf	plier,w
	iorwf	plier+1,w
	btfss	STATUS,Z	;test for early return
	goto	loop
	retlw	0		;done, result in prod
#endif

        psect   temp,global,class=BANK0,space=1,ovrld
btemp	ds	2
plier	ds	2
prod	ds	2

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3
	global	used_btemp4
	global	used_btemp5

	end
