;This file can be used to redirect execution from reset and
;interrupts to a program that has been moved from the
;default address at 0h, to another location e.g. using the
;-A option.

;To use this file just include the file on the command line
;using the picc, e.g.

;  c:\ht-pic\bin\picc main.c jump.as -17c756 -a4000h -rom4000-fffc


GLOBAL boot
GLOBAL powerup

	psect	jumps,class=CODE,delta=2,abs,ovrld
	psect	jumps

boot
	ljmp powerup		;jump to power up code
    	
;The following are the jumps to interrupt functions. If you want to
;enable the interrupt you must uncomment the, "ljmp int_func*" instruction,
;the two lines above,the GLOBAL definition, "GLOBAL int_func*",
;and "org ...." instruction.

;Or if you want to redirect unused interrupts to an error handling routine
;replace the "int_func*" labels with "boot" to cause a "reset", or another
;address being that of your error handling code.

;GLOBAL int_func8
;    	org	8h    	
;    	ljmp int_func8		;interrupt at 0x8, External Interrupt on RA0/INT pin.

;GLOBAL int_func16    	
;    	org	10h
;    	ljmp int_func16		;interrupt at 0x10, TMR0 overflow interrupt.
    	
;GLOBAL int_func24    	
;    	org	18h
;    	ljmp int_func24		;interrupt at 0x18, External Interrupt on T0CKI.

;GLOBAL int_func32    	
;    	org	20h
;    	ljmp int_func32		;interrupt at 0x20, Peripherals.
