#include	<math.h>
#include	<errno.h>

#define M_PI	3.14159265358979
#define M_PI_2	1.57079632679489

double
atan2(double y,double  x)
{
	double	v;

	if (x == 0) {
		if (y == 0) {
			errno = EDOM;
			return 0;
		}
		if (y > 0) {
			  return M_PI_2;
		}
		else {
			  return -M_PI_2;
		}
	}
	if (y == 0) {
		if (x > 0) {
			  return 0;
		}
		else {
			  return M_PI;
		}
	}
	if(fabs(x) >= fabs(y)) {
		v = atan(y/x);
		if( x < 0.0)
			if(y >= 0.0)
				v += M_PI;
			else
				v -= M_PI;
		return v;
	}
	v = -atan(x/y);
	if(y < 0.)
		v -= M_PI_2;
	else
		v += M_PI_2;
	return v;
}
