#ifdef	_PIC12
	psect	clrtext,class=ENTRY,delta=2
#else
	psect	clrtext,class=CODE,delta=2
#endif

#include	"sfr.h"


#ifdef	_PIC16
;	Copy the rdata psects

	global	copy_data,stringbase

;	Called with FSR containing the base address, and
;	W with the last address+1, source address in TABLPTR

copy_data
	movwf	count		;store end address
	movlw	0xD0|(stringbase>>16)	;set up ALUSTA
	movwf	STATUS		;set auto-increment, clear carry
	rrf	TBLPTRH		;divide address by two
	rrf	TBLPTRL
	tablrd	l,+,WREG	;prefetch
	btfsc	STATUS,C	;test LSB
	goto	midloop		;go do high byte

cpyloop
	tlrd	l,INDF		;get the low byte
	movf	FSR,w
	xorwf	count,w		;compare with count
	btfsc	STATUS,Z	;skip if not equal
	return			;done
midloop
	tablrd	h,+,INDF	;get the high byte, fetch more, increment
	movf	FSR,w
	cpfseq	count
	goto	cpyloop
	return			;all done

#endif
#ifdef	_PIC14
;	Copy the rdata psects

	global	copy_data,code_ptr,string_indir

;	Called with FSR containing the base address, and
;	W with the last address+1, source address in code_ptr

copy_data
	movwf	count		;store end address
cpyloop
	fcall	string_indir	;get byte
	movwf	INDF		;store
	incf	FSR		;update pointer
	movf	FSR,w		;test for completion
	xorwf	count,w
	btfss	STATUS,2	;skip if zero
	goto	cpyloop
	retlw	0		;all done

#endif

#ifdef	_PIC12
;	Copy the rdata psects

	global	copy_data,code_ptr,string_direct

;	Called with FSR containing the base address, and
;	W with the last address+1, source address in ptr (in common RAM)

copy_data
	movwf	count		;store end address
cpyloop
	movf	ptr,w		;get code pointer
	incf	ptr		;post increment it
	fcall	string_direct	;get byte
	movwf	INDF		;store
	incf	FSR		;update pointer
	movf	FSR,w		;test for completion
	andlw	1Fh
	xorwf	count,w
	btfss	STATUS,2	;skip if zero
	goto	cpyloop
	retlw	0		;all done

        psect   temp,global,class=BANK0,space=1,ovrld
ptr	ds	1
#endif

        psect   temp,global,class=BANK0,space=1,ovrld
count	ds	1
