#ifdef	_PIC12
	psect	init,class=ENTRY,delta=2
#else
	psect	init,class=CODE,delta=2
#endif

#include	"sfr.h"


;	Copy initialised data into bank1

	global	copy_data,copy_bank1,code_ptr
	global	__Lrdata_1,__Hrdata_1,__Lidata_1

;	Call copy_data with FSR containing the base address, and
;	W with the last address+1. Code_ptr has the source
;	address of the ROM image


copy_bank1
#ifdef	_PIC16
	movlw	__Lidata_1 & 0ffh
	movwf	TBLPTRL
	movlw	(__Lidata_1 >> 8) & 0ffh
	movwf	TBLPTRH
	movlw	__Lrdata_1 & 0xFF
	movwf	FSR
	movlw	__Hrdata_1 & 0xFF
	movlr	1
	call	copy_data
#else
#ifdef	_PIC12
	global	stringbase
	movlw	__Lidata_1 & 0ffh
	movwf	ptr
#else
	clrf	STATUS
	movlw	(__Lidata_1 >> 8)
	movwf	code_ptr+1
	movlw	__Lidata_1 & 0FFh
	movwf	code_ptr
#endif
	movlw	__Lrdata_1
	movwf	FSR
#ifdef	_PIC12
	movlw	__Hrdata_1 & 1Fh
#else
	movlw	__Hrdata_1 & 0FFh
#endif
	call	copy_data
#endif


#ifdef	_PIC12
        psect   temp,global,class=BANK0,space=1,ovrld
ptr	ds	1
count	ds	1
#endif
