#ifdef	_PIC12
	psect	init23,class=ENTRY,delta=2
#else
	psect	init23,class=CODE,delta=2
#endif

#include	"sfr.h"


;	Copy initialised data into bank3

	global	copy_data,copy_bank3,code_ptr
	global	__Lrdata_3,__Hrdata_3,__Lidata_3

;	Call copy_data with FSR containing the base address, and
;	W with the last address+1. Code_ptr has the source
;	address of the ROM image


copy_bank3
#ifdef	_PIC16
	movlw	__Lidata_3 & 0ffh
	movwf	TBLPTRL
	movlw	(__Lidata_3 >> 8) & 0ffh
	movwf	TBLPTRH
	movlw	__Lrdata_3 & 0xFF
	movwf	FSR
	movlw	__Hrdata_3 & 0FFh
	movlr	3
	call	copy_data
#else
#ifdef	_PIC12
	global	stringbase
	movlw	__Lidata_3 & 0ffh
	movwf	ptr
#else
	movlw	(__Lidata_3 >> 8)
	movwf	code_ptr+1
	movlw	__Lidata_3 & 0FFh
	movwf	code_ptr
#endif
	movlw	__Lrdata_3 & 0FFh
	movwf	FSR
#ifdef	_PIC12
	movlw	__Hrdata_3 & 01Fh
#else
	movlw	__Hrdata_3 & 0FFh
#endif
#ifdef	_PIC14
	bsf	STATUS,7		;set the IRP bit
#endif
	call	copy_data
#endif


#ifdef	_PIC12
        psect   temp,global,class=BANK0,space=1,ovrld
ptr	ds	1
count	ds	1
#endif
