;	Run-time startoff module for HI-TECH C for the Microchip PIC 16C5x
;
;	Copyright (C) 1995 HI-TECH Software
;
;	$Header$
;
;	$Log$
;	Revision 1.1  1998/04/02 06:59:33  clyde
;	Added assembler files
;

#include	"sfr.h"

	global	_main,start,_exit,powerup
	global	__Hbss,__Lbss,__Ldata,__Hdata,__Bdata

	fnconf	bss,?a,?
	fnroot	_main

pic16c5x	equ	1

	psect	data,class=RAM
	psect	bss,class=RAM,space=1
	psect	nvram,class=RAM,space=1
	psect	struct,ovrld,class=RAM,space=1
	psect	temp,ovrld,class=BANK0,space=1
	psect	code,class=CODE,delta=2
	psect	powerup,class=CODE,delta=2
#ifdef	_PIC12
	psect	text,class=ENTRY,delta=2
#else
	psect	text,class=CODE,delta=2
#endif
	psect	rbit,class=RAM,bit,space=1
	psect	strings,class=STRING,delta=2
	psect	stringtable,class=ENTRY,delta=2

	psect	vectors,ovrld,class=CODE,delta=2
resetloc
	goto	powerup & 0x1FF | (resetloc & not 0x1FF)

	psect	text

_exit
start
	clrf	STATUS

;	Clear the bss psect - remove this code to save space if
;	you are sure that this is not necessary

	movlw	__Lbss
	movwf	FSR
	goto	clrent
clrloop
	clrf	INDF
	incf	FSR,f
clrent
	movf	FSR,w
	xorlw	__Hbss | 0E0h
	btfss	STATUS,2	;test zero
	goto	clrloop
	
	ljmp	_main


	end	start
